<template>
  <div>
    <q-card bordered flat square class="q-pt-md scroll no-border" style="width: 170px">

      <div >
        <q-avatar size="170px" class="text-center" round>
          <img :src="source"/>
        </q-avatar>
      </div>
      <div class="absolute-bottom row justify-between" v-if="mode !== 'view'" >
        <q-btn round color="white" class="q-ml-xs q-my-xs text-green" @click="onAvatarButtonClick" icon="la la-edit" />
        <q-btn round color="white" class="q-mr-xs q-my-xs text-red" @click="clearImage" v-if="file" icon="la la-trash" />
      </div>
      <q-inner-loading :showing="combineLoading">
        <q-spinner-ios size="50px" color="primary" />
      </q-inner-loading>
        <q-file color="primary" dense
                @input="onChangeAvatar"
                accept="image/*"
                hide-bottom-space ref="fileField" class="q-ma-none" v-show="false"
                square borderless v-model="file"/>
<!--      </div>-->
    </q-card>

      <!-- modal Croper -->
  </div>
</template>

<script>
export default {
  name: "AvatarCard",
  props:{
    mode:{
      type: String,
    },
    loading:{
      type: Boolean
    },
    width:{
      type: Number,
      default: 206
    },
    height:{
      type: Number,
      default: 266
    },
    defaultAvatar:{
      type: String
    },
    value: {},
  },
  data() {
    return {
      isSelecting: false,
      file: null,
      source: null,
      isLoading: false
    }
  },
  mounted(){
    this.resetImage();
    this.$fileReader = new FileReader();
    this.$fileReader.addEventListener('loadstart',this.loadStart);
    this.$fileReader.addEventListener('loadend', this.loadEnd);
    this.$fileReader.addEventListener('load', this.handler);
    this.$fileReader.addEventListener('error',this.loadError)
  },
  beforeDestroy() {
    this.$fileReader.removeEventListener('loadstart', this.loadStart)
    this.$fileReader.removeEventListener('loadend', this.loadEnd)
    this.$fileReader.removeEventListener('load',this.handler)
    this.$fileReader.removeEventListener('error',this.loadError)
  },
  methods:{
    onAvatarButtonClick(){
      this.$refs.fileField.$el.click();
    },
    onChangeAvatar(){
      if(this.file){
        this.$fileReader.readAsDataURL(this.file);
      }
    },
    update(){
      this.$emit('input', this.file);
    },
    handler(event){
      console.log('event.target',event.target);
      this.source = event.target.result
      this.update();
    },
    clearImage(){
      this.file = null;
      this.update();
      this.resetImage();
    },

    resetImage(){
      this.source = this.value||this.defaultAvatar;
    },

    loadStart(){
      this.isLoading = true
    },
    loadEnd(){
      this.isLoading = false
    },
    loadError(error){
        this.isLoading = false;
        this.$q.notify({
          type: 'negative',
          class: ['bg-red', 'text-white'],
          icon: 'la la-exclamation-circle',
          html: true,
          message: 'Impossible de charger cette image.<br/>' +
            'Veuilez verifier le format du fichier et sa taille.'
        })
    }
  },
  computed:{
    combineLoading(){
      return this.isLoading || this.loading
    },
  },
  watch:{
    value(){
      if(this.value instanceof Blob){
        this.$fileReader.readAsDataURL(this.value);
      }
    }
  }
}
</script>

<style  scoped lang="scss">
.avatar-card {
  .black {
    background-color: rgba(0,0,0,50%);
  }
}
</style>
